#1298 closed defect (fixed)

POSIX timer_settime incorrectly reject absolute timeouts in past.

Reported by: Tim FitzGeorge Owned by: Joel Sherrill
Priority: normal Milestone: 4.11
Component: score Version: 4.9
Severity: normal Keywords:
Cc: gedare@…, cynt6007@… Blocked By:
Blocking:

Description

The POSIX standard states that when timer_settime has timeout specified for a time that has already occurred, the expiration notification should be made immediately, and the call should succeed.

The RTEMS HEAD implementation has a specific test for this case (for TIMER_ABSTIME which incorrectly rejects the timeout with an error. This should be modified to conform to the standard.

Note that there is no test for a relative timeout in the past; this is passed straight to the watchdog routines. The 4.8 branch also lacks a check for both absolute and relative timers.


This bug report covers an issue first described on bug report 1296.

Attachments (1)

timer_settime.patch (3.4 KB) - added by Daniel Ramirez on Dec 5, 2013 at 5:27:25 PM.
Patch to fix bug and update test cases

Download all attachments as: .zip

Change History (4)

Changed on Dec 5, 2013 at 5:27:25 PM by Daniel Ramirez

Attachment: timer_settime.patch added

Patch to fix bug and update test cases

comment:1 Changed on Jan 8, 2014 at 4:36:39 AM by cynt6007

Status: newassigned, cynt6007@vandals.uidaho.edu

comment:2 Changed on Jan 9, 2014 at 2:03:02 PM by Gedare Bloom

Resolution: fixed
Status: assignedclosed, gedare@rtems.org

Patch committed. Close if OK, or request back-port if needed.

comment:3 Changed on Jan 9, 2014 at 2:03:50 PM by Gedare Bloom

Milestone: 4.94.11
Note: See TracTickets for help on using tickets.